Makefile 7.7 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235
  1. # set the shell to bash always
  2. SHELL := /bin/bash
  3. # set make and shell flags to exit on errors
  4. MAKEFLAGS += --warn-undefined-variables
  5. .SHELLFLAGS := -euo pipefail -c
  6. ARCH = amd64 arm64
  7. BUILD_ARGS ?=
  8. # default target is build
  9. .DEFAULT_GOAL := all
  10. .PHONY: all
  11. all: $(addprefix build-,$(ARCH))
  12. # Image registry for build/push image targets
  13. IMAGE_REGISTRY ?= ghcr.io/external-secrets/external-secrets
  14. # Produce CRDs that work back to Kubernetes 1.11 (no version conversion)
  15. CRD_OPTIONS ?= "crd:trivialVersions=true"
  16. CRD_DIR ?= deploy/crds
  17. HELM_DIR ?= deploy/charts/external-secrets
  18. OUTPUT_DIR ?= bin
  19. # Get the currently used golang install path (in GOPATH/bin, unless GOBIN is set)
  20. ifeq (,$(shell go env GOBIN))
  21. GOBIN=$(shell go env GOPATH)/bin
  22. else
  23. GOBIN=$(shell go env GOBIN)
  24. endif
  25. # check if there are any existing `git tag` values
  26. ifeq ($(shell git tag),)
  27. # no tags found - default to initial tag `v0.0.0`
  28. VERSION := $(shell echo "v0.0.0-$$(git rev-list HEAD --count)-g$$(git describe --dirty --always)" | sed 's/-/./2' | sed 's/-/./2')
  29. else
  30. # use tags
  31. VERSION := $(shell git describe --dirty --always --tags --exclude 'helm*' | sed 's/-/./2' | sed 's/-/./2')
  32. endif
  33. # ====================================================================================
  34. # Colors
  35. BLUE := $(shell printf "\033[34m")
  36. YELLOW := $(shell printf "\033[33m")
  37. RED := $(shell printf "\033[31m")
  38. GREEN := $(shell printf "\033[32m")
  39. CNone := $(shell printf "\033[0m")
  40. # ====================================================================================
  41. # Logger
  42. TIME_LONG = `date +%Y-%m-%d' '%H:%M:%S`
  43. TIME_SHORT = `date +%H:%M:%S`
  44. TIME = $(TIME_SHORT)
  45. INFO = echo ${TIME} ${BLUE}[ .. ]${CNone}
  46. WARN = echo ${TIME} ${YELLOW}[WARN]${CNone}
  47. ERR = echo ${TIME} ${RED}[FAIL]${CNone}
  48. OK = echo ${TIME} ${GREEN}[ OK ]${CNone}
  49. FAIL = (echo ${TIME} ${RED}[FAIL]${CNone} && false)
  50. # ====================================================================================
  51. # Conformance
  52. # Ensure a PR is ready for review.
  53. reviewable: generate helm.generate
  54. @go mod tidy
  55. # Ensure branch is clean.
  56. check-diff: reviewable
  57. @$(INFO) checking that branch is clean
  58. @test -z "$$(git status --porcelain)" || (echo "$$(git status --porcelain)" && $(FAIL))
  59. @$(OK) branch is clean
  60. # ====================================================================================
  61. # Golang
  62. .PHONY: test
  63. test: generate ## Run tests
  64. @$(INFO) go test unit-tests
  65. go test -race -v $(shell go list ./... | grep -v e2e) -coverprofile cover.out
  66. @$(OK) go test unit-tests
  67. .PHONY: test.e2e
  68. test.e2e: generate ## Run e2e tests
  69. @$(INFO) go test e2e-tests
  70. $(MAKE) -C ./e2e test
  71. @$(OK) go test unit-tests
  72. .PHONY: build
  73. build: $(addprefix build-,$(ARCH))
  74. .PHONY: build-%
  75. build-%: generate ## Build binary for the specified arch
  76. @$(INFO) go build $*
  77. @CGO_ENABLED=0 GOOS=linux GOARCH=$* \
  78. go build -o '$(OUTPUT_DIR)/external-secrets-linux-$*' main.go
  79. @$(OK) go build $*
  80. # Check install of golanci-lint
  81. lint.check:
  82. @if ! golangci-lint --version > /dev/null 2>&1; then \
  83. echo -e "\033[0;33mgolangci-lint is not installed: run \`\033[0;32mmake lint.install\033[0m\033[0;33m\` or install it from https://golangci-lint.run\033[0m"; \
  84. exit 1; \
  85. fi
  86. # installs golangci-lint to the go bin dir
  87. lint.install:
  88. @if ! golangci-lint --version > /dev/null 2>&1; then \
  89. echo "Installing golangci-lint"; \
  90. curl -sfL https://install.goreleaser.com/github.com/golangci/golangci-lint.sh | sh -s -- -b $(GOBIN) v1.33.0; \
  91. fi
  92. lint: lint.check ## run golangci-lint
  93. @if ! golangci-lint run; then \
  94. echo -e "\033[0;33mgolangci-lint failed: some checks can be fixed with \`\033[0;32mmake fmt\033[0m\033[0;33m\`\033[0m"; \
  95. exit 1; \
  96. fi
  97. fmt: lint.check ## ensure consistent code style
  98. @go mod tidy
  99. @go fmt ./...
  100. @golangci-lint run --fix > /dev/null 2>&1 || true
  101. @$(OK) Ensured consistent code style
  102. generate: ## Generate code and crds
  103. @go run sigs.k8s.io/controller-tools/cmd/controller-gen object:headerFile="hack/boilerplate.go.txt" paths="./..."
  104. @go run sigs.k8s.io/controller-tools/cmd/controller-gen $(CRD_OPTIONS) paths="./..." output:crd:artifacts:config=$(CRD_DIR)
  105. # Remove extra header lines in generated CRDs
  106. @for i in $(CRD_DIR)/*.yaml; do \
  107. tail -n +3 <"$$i" >"$$i.bkp" && \
  108. cp "$$i.bkp" "$$i" && \
  109. rm "$$i.bkp"; \
  110. done
  111. @$(OK) Finished generating deepcopy and crds
  112. # ====================================================================================
  113. # Local Utility
  114. # This is for running out-of-cluster locally, and is for convenience.
  115. # For more control, try running the binary directly with different arguments.
  116. run: generate
  117. go run ./main.go
  118. # Generate manifests from helm chart
  119. manifests: helm.generate
  120. mkdir -p $(OUTPUT_DIR)/deploy/manifests
  121. helm template external-secrets $(HELM_DIR) -f deploy/manifests/helm-values.yaml > $(OUTPUT_DIR)/deploy/manifests/external-secrets.yaml
  122. # Install CRDs into a cluster. This is for convenience.
  123. crds.install: generate
  124. kubectl apply -f $(CRD_DIR)
  125. # Uninstall CRDs from a cluster. This is for convenience.
  126. crds.uninstall:
  127. kubectl delete -f $(CRD_DIR)
  128. # ====================================================================================
  129. # Helm Chart
  130. helm.docs: ## Generate helm docs
  131. @cd $(HELM_DIR); \
  132. docker run --rm -v $(shell pwd)/$(HELM_DIR):/helm-docs -u $(shell id -u) jnorwood/helm-docs:v1.5.0
  133. HELM_VERSION ?= $(shell helm show chart $(HELM_DIR) | grep 'version:' | sed 's/version: //g')
  134. helm.build: helm.generate ## Build helm chart
  135. @$(INFO) helm package
  136. @helm package $(HELM_DIR) --dependency-update --destination $(OUTPUT_DIR)/chart
  137. @mv $(OUTPUT_DIR)/chart/external-secrets-$(HELM_VERSION).tgz $(OUTPUT_DIR)/chart/external-secrets.tgz
  138. @$(OK) helm package
  139. # Copy crds to helm chart directory
  140. helm.generate: helm.docs
  141. @cp $(CRD_DIR)/*.yaml $(HELM_DIR)/templates/crds/
  142. # Add helm if statement for controlling the install of CRDs
  143. @for i in $(HELM_DIR)/templates/crds/*.yaml; do \
  144. cp "$$i" "$$i.bkp" && \
  145. echo "{{- if .Values.installCRDs }}" > "$$i" && \
  146. cat "$$i.bkp" >> "$$i" && \
  147. echo "{{- end }}" >> "$$i" && \
  148. rm "$$i.bkp"; \
  149. done
  150. @$(OK) Finished generating helm chart files
  151. # ====================================================================================
  152. # Documentation
  153. .PHONY: docs
  154. docs: generate
  155. $(MAKE) -C ./hack/api-docs build
  156. .PHONY: serve-docs
  157. serve-docs:
  158. $(MAKE) -C ./hack/api-docs serve
  159. # ====================================================================================
  160. # Build Artifacts
  161. build.all: docker.build helm.build
  162. docker.build: $(addprefix build-,$(ARCH)) ## Build the docker image
  163. @$(INFO) docker build
  164. @docker build . $(BUILD_ARGS) -t $(IMAGE_REGISTRY):$(VERSION)
  165. @$(OK) docker build
  166. docker.push:
  167. @$(INFO) docker push
  168. @docker push $(IMAGE_REGISTRY):$(VERSION)
  169. @$(OK) docker push
  170. # RELEASE_TAG is tag to promote. Default is promooting to main branch, but can be overriden
  171. # to promote a tag to a specific version.
  172. RELEASE_TAG ?= main
  173. SOURCE_TAG ?= $(VERSION)
  174. docker.promote:
  175. @$(INFO) promoting $(SOURCE_TAG) to $(RELEASE_TAG)
  176. docker manifest inspect $(IMAGE_REGISTRY):$(SOURCE_TAG) > .tagmanifest
  177. for digest in $$(jq -r '.manifests[].digest' < .tagmanifest); do \
  178. docker pull $(IMAGE_REGISTRY)@$$digest; \
  179. done
  180. docker manifest create $(IMAGE_REGISTRY):$(RELEASE_TAG) \
  181. $$(jq -j '"--amend $(IMAGE_REGISTRY)@" + .manifests[].digest + " "' < .tagmanifest)
  182. docker manifest push $(IMAGE_REGISTRY):$(RELEASE_TAG)
  183. @$(OK) docker push $(RELEASE_TAG) \
  184. # ====================================================================================
  185. # Help
  186. # only comments after make target name are shown as help text
  187. help: ## displays this help message
  188. @echo -e "$$(grep -hE '^\S+:.*##' $(MAKEFILE_LIST) | sed -e 's/:.*##\s*/:/' -e 's/^\(.\+\):\(.*\)/\\x1b[36m\1\\x1b[m:\2/' | column -c2 -t -s : | sort)"